"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class InputEleRef {
    constructor() {
        this.checkedItemList = ["checkbox", "radio"];
        this.eventObject = { change: false, blur: false, focus: false, submit: false, keyUp: false };
    }
    bindRef(ele) {
        if (this.element != ele) {
            this.element = ele;
            this.element.value = this.defaultValue || null;
            this.element.checked = this.defaultValue || null;
            if (this.eventObject.change) {
                this.element.addEventListener("change", (e) => {
                    let vstr = this.processExecution();
                    if (this.onChange) {
                        this.onChange(vstr, e);
                    }
                });
            }
            if (this.eventObject.keyUp) {
                this.element.addEventListener("keyup", (e) => {
                    let vstr = this.processExecution();
                    if (this.onKeyUp) {
                        this.onKeyUp(vstr, e);
                    }
                });
            }
            if (this.eventObject.blur) {
                this.element.addEventListener("blur", (e) => {
                    let vstr = this.processExecution();
                    if (this.onBlur) {
                        this.onBlur(vstr, e);
                    }
                });
            }
            if (this.eventObject.focus) {
                this.element.addEventListener("blur", (e) => {
                    let vstr = this.processExecution();
                    if (this.onFocus) {
                        this.onFocus(vstr, e);
                    }
                });
            }
        }
    }
    processExecution() {
        let vstr = null;
        if (this.parse) {
            this.element.value = this.parse(this.element.value);
        }
        if (this.validation) {
            vstr = this.validation(this.element.value);
        }
        return vstr;
    }
    getValue() {
        if (this.checkedItemList.filter((n) => this.element.type == n).length > 0) {
            return this.element.checked;
        }
        return this.element.value;
    }
    setValue(value) {
        this.element.checked = value;
        this.element.value = value;
    }
}
exports.default = InputEleRef;
//# sourceMappingURL=InputEleRef.js.map